import lua;

import std.math;

import shot;
import command;
import game;

class Bullet : public Shot {
public:
	this(float x, float y, float sx, float sy, Sprite sprite,
		 lua_State lua, char[] fn, Game game, int color) {
		super(x, y, sx, sy, sprite);
		command_ = new Command(lua, fn, game, this, color);
		alive_ = true;
		wait_ = 0;
	}

	void move() {
		if (wait_ == 0) {
			command_.run();
		}
		else {
			wait_--;
		}
		super.move();
	}

	void noticeChangeDirection() {
		float r = atan2(sx_, sy_);
		radian_ = cast(int)((r / PI + 1) * 16);
	}

	void wait(int t) {
		wait_ = t;
	}

private:
	Command command_;

	int wait_;

} 
