import std.string;

import cpu;
import padinput;
import axis;
import rc;
import player;
import log;

private:
struct CpuInfoHolder {
	Player player;
}
CpuInfoHolder cpuInfoHolder_;

extern (C) {
	double CpuInfo_getPlayerSize_(CpuInfo* info) {
		return 6;
	}
	double CpuInfo_getPlayerSpd_(CpuInfo* info) {
		return cpuInfoHolder_.player.playerSpeed();
	}
	double CpuInfo_getFps_(CpuInfo* info) {
		return 1;
	}
	int CpuInfo_getTurn_(CpuInfo* info) {
		return cpuInfoHolder_.player.turn();
	}
	double CpuInfo_getSpf_(CpuInfo* info) {
		return 1;
	}
}

public:

class CpuInput : public PadInput {
public:
	this(Player player) {
		player_ = player;
		cpu_ = Cpu_getDefaultCpu();
		info_ = CpuInfoCave_new();

		cpuInfoHolder_.player = player;

		CpuInfo_set_getPlayerSize(info_, &CpuInfo_getPlayerSize_);
		CpuInfo_set_getPlayerSpd(info_, &CpuInfo_getPlayerSpd_);
		CpuInfo_set_getFps(info_, &CpuInfo_getFps_);
		CpuInfo_set_getTurn(info_, &CpuInfo_getTurn_);
		CpuInfo_set_getSpf(info_, &CpuInfo_getSpf_);
		CpuInfo_setPlayerMaxPnt(info_,
								player_.screenWidth(), player_.screenHeight());

		Cpu_setCpuInfomation(info_);

		mode_ = 0;
	}
	~this() {
		Cpu_delete(cpu_);
		CpuInfoCave_delete(info_);
	}

	Axis getAxis() {
		CpuInfo_setPlayerPnt(info_, player_.x(), player_.y());
		int len;
		float* x, y, sx, sy;

		player_.getEnemyBullets(len, x, y, sx, sy);

		CpuInfo_setBulletsPosSpd(info_, len, x, y, sx, sy);

		int a = Cpu_getAxis(cpu_);
		return new Axis(Axis.createFromSmallCode(a));
	}
	bit getButton(int id) {
		// OO ʤ衣

		int t = player_.turn() & 255;
		switch (mode_) {
		case 1: {
			if (player_.gauge() > 90) {
				mode_ = 99;
				modeTurn_ = 0;
			}
			break;
		}
		case 99: {
			if (modeTurn_ > 100) {
				mode_ = 1;
				modeTurn_ = 0;
			}
			if (id == 1) return true;
			break;
		}
		case 2: {
			if (id == 0) return true;
			break;
		}
		case 3: {
			if (!(modeTurn_ & 15) && id == 1) return true;
			break;
		}
		case 4: {
			if (rnd(2) == 0 && id == 0) return true;
			if (rnd(30) == 0 && id == 1) return true;
			break;
		}
		default: {
			if (t < 120) {
				if (id == 0) return true;
			}
			else if (t > 160 && t < 240) {
				if (id == 1) return true;
			}
			break;
		}
		}

		if (t == 255) {
			mode_ = rnd(6);
			modeTurn_ = 0;
		}

		modeTurn_++;

		return false;
	}

	void registerShot(float x, float y, float sx, float sy) {
		Cpu_registShot(cpu_, x, y, sx, sy);
	}

private:
	Player player_;
	CpuInputBase* cpu_;
	CpuInfoCave* info_;
	int mode_;
	int modeTurn_;
}


