import SDL;

class FpsTimer {
public:
	this() {
		fps_ = 60;
		ticksPerFrame_ = 1000 / 60;
		shouldSkip_ = false;
		turns_ = 0;
		frameDropTurns_ = 0;
		prevDrawTicks_ = 0;
	}

	void setFps(int fps) {
		fps_ = fps;
		ticksPerFrame_ = 1000 / fps;
	}

	void start() {
		startTicks_ = ticks_ = SDL_GetTicks();
		turns_ = frameDropTurns_ = 0;
	}

	void wait() {
		ticks_ += ticksPerFrame_;

		shouldSkip_ = false;
		turns_++;

		int now = SDL_GetTicks();
		if (ticks_ < now) {
			if (prevDrawTicks_ > now - 100) {
				frameDropTurns_++;
				shouldSkip_ = true;
			}
			else {
				prevDrawTicks_ = now;
			}
			return;
		}

		prevDrawTicks_ = now;
		SDL_Delay(ticks_ - now);
	}

	int getTrueFps() {
		if (ticks_ - startTicks_ != 0) {
			return (turns_ - frameDropTurns_) * 1000 / (ticks_ - startTicks_);
		}
		else {
			return 0;
		}
	}

	bit shouldSkip() { return shouldSkip_; }

	int getTurn() { return turns_; }
	int getDroppedTurn() { return frameDropTurns_; }
	int getFps() { return fps_; }
	int getEllapsedTicks() { return ticks_ - startTicks_; }
	int getEllapsedSecond() { return getEllapsedTicks() / 1000; }

private:
	int startTicks_;
	int fps_;
	int ticksPerFrame_;
	int ticks_;
	bit shouldSkip_;
	int turns_;
	int frameDropTurns_;
    int prevDrawTicks_;

};
