import SDL;

SDL_Surface*
MySDL_CreateRGBSurface(Uint32 w, Uint32 h) {
	return MySDL_DisplayFormat(
		SDL_CreateRGBSurface(SDL_SWSURFACE, w, h, 16, 0,0,0,0));
}

SDL_Surface*
MySDL_CreateRGBSurface(Uint32 flags, Uint32 w, Uint32 h, Uint32 bpp) {
	return SDL_CreateRGBSurface(flags, w, h, bpp, 0,0,0,0);
}

void
MySDL_BlitSurface(SDL_Surface* src, int sx, int sy, int sw, int sh,
				  SDL_Surface* dst, int dx, int dy) {
	SDL_Rect srcRect, dstRect;
	srcRect.x = sx; srcRect.y = sy; srcRect.w = sw; srcRect.h = sh;
	dstRect.x = dx; dstRect.y = dy;
	SDL_BlitSurface(src, &srcRect, dst, &dstRect);
}

void
MySDL_BlitSurface(SDL_Surface* src, SDL_Surface* dst, int x, int y) {
	SDL_Rect dstRect;
	dstRect.x = x; dstRect.y = y;
	SDL_BlitSurface(src, cast(SDL_Rect*)0, dst, &dstRect);
}

void
MySDL_BlitSurfaceCenter(SDL_Surface* src, SDL_Surface* dst, int x, int y) {
	SDL_Rect dstRect;
	dstRect.x = x - (src.w >> 1); dstRect.y = y - (src.h >> 1);
	SDL_BlitSurface(src, cast(SDL_Rect*)0, dst, &dstRect);
}

void MySDL_BlitSurface(SDL_Surface* src, SDL_Surface* dst) {
	SDL_BlitSurface(src, cast(SDL_Rect*)0, dst, cast(SDL_Rect*)0);
}

void MySDL_SetColorKey(SDL_Surface* surf, Uint32 flags,
                       Uint8 r, Uint8 g, Uint8 b)
{
	SDL_SetColorKey(surf, flags, SDL_MapRGB(surf.format, r, g, b));
}

SDL_Surface* MySDL_DisplayFormat(SDL_Surface* src) {
	SDL_Surface* dst = SDL_DisplayFormat(src);
	SDL_FreeSurface(src);
	return dst;
}

SDL_Surface* MySDL_LoadBMP(char[] file) {
	return MySDL_DisplayFormat(SDL_LoadBMP(file));
}

SDL_Color MySDL_Color(Uint8 r, Uint8 g, Uint8 b) {
	SDL_Color ret;
	ret.r = r;
	ret.g = g;
	ret.b = b;
	ret.unused = 255;
	return ret;
}

SDL_Rect MySDL_Rect(Sint16 x, Sint16 y, Uint16 w, Uint16 h) {
	SDL_Rect ret;
	ret.x = x;
	ret.y = y;
	ret.w = w;
	ret.h = h;
	return ret;
}

