import scene;
import log;
import mysdl;
import cave;
import padinput;

import scene_game;

import std.file;
import std.string;

class SceneSelect : Scene {
public:
	this() {
		Log.info("scene select");

        state_ = State.PLAYERS;

        font_ = MySDL_LoadBMP("data/strings.bmp");
        MySDL_SetColorKey(font_, SDL_SRCCOLORKEY, 0, 0, 0);

        input_ = Cave.obj.padInput;
		screen_ = Cave.obj.screen;

        char[] strs = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ.<>^ ";
        foreach (int i, char c; strs) {
            ch2ind_[c] = i;
        }

        title_.length = State.END;
        title_[0] = `SELECT 1P OR 2P GAME`;
        title_[1] = `SELECT 1P CHARACTOR`;
        title_[2] = `SELECT 2P CHARACTOR`;

        select_.length = State.END;
        select_[0] ~= `1P VS CPU`;
        select_[0] ~= `1P VS 2P`;
        foreach (char[] name; listdir(`data/players`)) {
            if (name.length >= 1 && name[0] != '.') {
                Log.info("player commited: " ~ name);
                playerNames_ ~= name;
                select_[1] ~= name;
                select_[2] ~= name;
            }
        }

        resetPos();
	}

	bit isEnd() {
        return state_ == State.END;
	}

	Scene getNext() {
		return new SceneGame();
	}

	void run() {
        char[][] sel = select_[state_];

        drawString(title_[state_], 170, 170);

        foreach (int i, char[] s; sel) {
            drawString(s, 200, 200+20*i);
        }
        drawString(`>`, 180, 200+20*pos_);

        if (releaseWaiting_) {
            if (input_.getButton(0) || input_.getButton(1) ||
                input_.getAxis != Axis.NONE)
            {
                return;
            }
            releaseWaiting_ = false;
        }

        if (pos_ > 0 && input_.getAxis == Axis.UP) {
            releaseWaiting_ = true;
            pos_--;
        }
        else if (pos_ < sel.length-1 && input_.getAxis == Axis.DOWN) {
            releaseWaiting_ = true;
            pos_++;
        }

        if (input_.getButton(0)) {
            if (state_ == State.PLAYERS) {
                Cave.rc.set(`playerModeIsCpu`, std.string.toString(!pos_));
            }
            else if (state_ == State.PLAYER1) {
                Cave.rc.set(`playerCharactorBlack`, playerNames_[pos_]);
            }
            else if (state_ == State.PLAYER2) {
                Cave.rc.set(`playerCharactorWhite`, playerNames_[pos_]);
                Cave.rc.save();
            }

            releaseWaiting_ = true;
            state_++;

            resetPos();
        }
        else if (input_.getButton(1) && state_ != State.PLAYERS) {
            releaseWaiting_ = true;
            state_--;

            resetPos();
        }
	}

private:
    void resetPos() {
        pos_ = 0;
        if (state_ == State.PLAYERS) {
            pos_ = !Cave.rc.getInt(`playerModeIsCpu`);
        }
        else if (state_ == State.PLAYER1) {
            char[] name = Cave.rc.get(`playerCharactorBlack`);
            foreach (int i, char[] s; playerNames_) {
                if (s == name) {
                    pos_ = i;
                    break;
                }
            }
        }
        else if (state_ == State.PLAYER2) {
            char[] name = Cave.rc.get(`playerCharactorWhite`);
            foreach (int i, char[] s; playerNames_) {
                if (s == name) {
                    pos_ = i;
                    break;
                }
            }
        }
    }

    void drawString(char[] str, int x, int y) {
        static const float DOT_PER_CHAR = 300.0 / 41;
        static const int CHAR_WIDTH = 7;
        static const int CHAR_HEIGHT = 14;

        foreach (int i, char c; str) {
            int ind = ch2ind_[c];
            int sx = cast(int)(DOT_PER_CHAR*ind);
            int dx = cast(int)(DOT_PER_CHAR*i) + x;
            MySDL_BlitSurface(font_, sx, 0, CHAR_WIDTH, CHAR_HEIGHT,
                              screen_, dx, y);
        }
    }

private:
    enum State { PLAYERS = 0, PLAYER1, PLAYER2, END };
    State state_;

    SDL_Surface* font_;
    int[char] ch2ind_;

    PadInput input_;
    SDL_Surface* screen_;

    int pos_;
    char[][] title_;
    char[][][] select_;

    bool releaseWaiting_;

    char[][] playerNames_;

};

