import log;
import mysdl;

class Sprite {
public:
	this(SDL_Surface*[] surfs)
	in {
		int l = surfs.length;
		while (l > 0) {
			if ((l >> 1) != (l / 2)) {
				Log.error("sprites surfs must 2^n");
			}
			l >>= 1;
		}
	}
	body {
		surfs_ = surfs;
		period_ = surfs.length - 1;
	}

	~this() {
		for (int i = 0; i < surfs_.length; i++) {
			SDL_FreeSurface(surfs_[i]);
		}
	}

	void draw(SDL_Surface* dst, int x, int y, int turn) {
		MySDL_BlitSurfaceCenter(surfs_[turn & period_], dst, x, y);
	}

private:
	SDL_Surface*[] surfs_;
	int period_;
}
